Overview | Package | Class | Tree | Deprecated | Index | Help
Qt Jambi Home |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QTextDocument

    java.lang.Object
      com.trolltech.qt.QSignalEmitter
          com.trolltech.qt.QtJambiObject
              com.trolltech.qt.core.QObject
                  com.trolltech.qt.gui.QTextDocument

All Implemented Interfaces:
  QtJambiInterface

    public class QTextDocument

extends QObject

The `QTextDocument` class holds formatted text that can be viewed and edited using a `QTextEdit`.

`QTextDocument` is a container for structured rich text documents, providing support for styled text and various types of document elements, such as lists, tables, frames, and images. They can be created for use in a `QTextEdit`, or used independently.

Each document element is described by an associated format object. Each format object is treated as a unique object by QTextDocuments, and can be passed to `objectForFormat` to obtain the document element that it is applied to.

A `QTextDocument` can be edited programmatically using a `QTextCursor`, and its contents can be examined by traversing the document structure. The entire document structure is stored as a hierarchy of document elements beneath the root frame, found with the `rootFrame` function. Alternatively, if you just want to iterate over the textual contents of the document you can use `begin`, `end`, and `findBlock` to retrieve text blocks that you can examine and iterate over.

The layout of a document is determined by the `documentLayout`; you can create your own `QAbstractTextDocumentLayout` subclass and set it using `setDocumentLayout` if you want to use your own layout logic. The document's title can be obtained by calling the documentTitle() function.

The `toPlainText` and `toHtml` convenience functions allow you to retrieve the contents of the document as plain text and HTML. The document's text can be searched using the `find` functions.

Undo/redo of operations performed on the document can be controlled using the `setUndoRedoEnabled` function. The undo/redo system can be controlled by an editor widget through the `undo` and `redo` slots; the document also provides `contentsChanged`, `undoAvailable`, and `redoAvailable` signals that inform connected editor widgets about the state of the undo/redo system.

See Also:
  `QTextCursor`, `QTextEdit`, Rich Text Processing

Nested Class Summary
`static class` | `QTextDocument.FindFlag` This enum describes the options available to `QTextDocument`'s find function.
`static class` | `QTextDocument.FindFlags` This QFlag class provides flags for the int enum.
`static class` | `QTextDocument.MetaInformation` This enum describes the different types of meta information that can be added to a document.
`static class` | `QTextDocument.ResourceType` This enum describes the types of resources that can be loaded by `QTextDocument`'s `loadResource` function.

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1<A>, QSignalEmitter.Signal2<A,B>, QSignalEmitter.Signal3<A,B,C>, QSignalEmitter.Signal4<A,B,C,D>, QSignalEmitter.Signal5<A,B,C,D,E>, QSignalEmitter.Signal6<A,B,C,D,E,F>, QSignalEmitter.Signal7<A,B,C,D,E,F,G>, QSignalEmitter.Signal8<A,B,C,D,E,F,G,H>, QSignalEmitter.Signal9<A,B,C,D,E,F,G,H,I>`

Field Summary
`QSignalEmitter.Signal1<java.lang.Integer>` | `blockCountChanged` This signal is emitted when the total number of text blocks in the document changes.
`QSignalEmitter.Signal3<java.lang.Integer,java.lang.Integer,java.lang.Integer>` | `contentsChange` This signal is emitted whenever the document's content changes; for example, when text is inserted or deleted, or when formatting is applied.
`QSignalEmitter.Signal0` | `contentsChanged` This signal is emitted whenever the document's content changes; for example, when text is inserted or deleted, or when formatting is applied.
`QSignalEmitter.Signal1<QTextCursor>` | `cursorPositionChanged` This signal is emitted whenever the position of a cursor changed due to an editing operation.
`QSignalEmitter.Signal1<java.lang.Boolean>` | `modificationChanged` This signal is emitted whenever the content of the document changes in a way that affects the modification state.
`QSignalEmitter.Signal1<java.lang.Boolean>` | `redoAvailable` This signal is emitted whenever redo operations become available (`arg__1` is true) or unavailable (`arg__1` is false).
`QSignalEmitter.Signal1<java.lang.Boolean>` | `undoAvailable` This signal is emitted whenever undo operations become available (`arg__1` is true) or unavailable (`arg__1` is false).

Constructor Summary
`QTextDocument()` Equivalent to `QTextDocument`(0).
`QTextDocument(QObject parent)` Constructs an empty `QTextDocument` with the given `parent`.
`QTextDocument(java.lang.String text)` Equivalent to `QTextDocument`(`text`, 0).
`QTextDocument(java.lang.String text, QObject parent)` Constructs a `QTextDocument` containing the plain (unformatted) `text` specified, and with the given `parent`.

Method Summary
`void` | `addResource(int type, QUrl name, java.lang.Object resource)` Adds the resource `resource` to the resource cache, using `type` and `name` as identifiers.
`void` | `adjustSize()` Adjusts the document to a reasonable size.
`java.util.List<QTextFormat>` | `allFormats()` Returns a vector of text formats for all the formats used in the document.
`QTextBlock` | `begin()` Returns the document's first text block.
`int` | `blockCount()` Returns the number of text blocks in the document.
`void` | `clear()` Clears the document.
`QTextDocument` | `clone()` Equivalent to clone(0).
`QTextDocument` | `clone(QObject parent)` Creates a new `QTextDocument` that is a copy of this text document.
`protected QTextObject` | `createObject(QTextFormat f)` Creates and returns a new document object (a `QTextObject`), based on the given `f`.
`QFont` | `defaultFont()` Returns the default font used to display the document's text.
`java.lang.String` | `defaultStyleSheet()` The default style sheet is applied to all newly HTML formatted text that is inserted into the document, for example using `setHtml` or QTextCursor::insertHtml().
`QTextOption` | `defaultTextOption()` Returns the default text option will be set on all `QTextLayout`s in the document..
`QAbstractTextDocumentLayout` | `documentLayout()` Returns the document layout for this document.
`void` | `drawContents(QPainter painter)` Equivalent to `drawContents`(`painter`, QRectF()).
`void` | `drawContents(QPainter painter, QRectF rect)` Draws the content of the document with painter `painter`, clipped to `rect`.
`QTextBlock` | `end()` This function returns a block to test for the end of the document while iterating over it.
`QTextCursor` | `find(QRegExp expr)` Equivalent to find(`expr`, 0, 0).
`QTextCursor` | `find(QRegExp expr, int from)` Equivalent to find(`expr`, `from`, 0).
`QTextCursor` | `find(QRegExp expr, int from, QTextDocument.FindFlag... options)` Finds the next occurrence, matching the regular expression, `expr`, in the document.
`QTextCursor` | `find(QRegExp expr, int from, QTextDocument.FindFlags options)` Finds the next occurrence, matching the regular expression, `expr`, in the document.
`QTextCursor` | `find(QRegExp expr, QTextCursor from)` Equivalent to find(`expr`, `from`, 0).
`QTextCursor` | `find(QRegExp expr, QTextCursor from, QTextDocument.FindFlag... options)` Finds the next occurrence, matching the regular expression, `expr`, in the document.
`QTextCursor` | `find(QRegExp expr, QTextCursor from, QTextDocument.FindFlags options)` Finds the next occurrence, matching the regular expression, `expr`, in the document.
`QTextCursor` | `find(java.lang.String subString)` Equivalent to find(`subString`, 0, 0).
`QTextCursor` | `find(java.lang.String subString, int from)` Equivalent to find(`subString`, `from`, 0).
`QTextCursor` | `find(java.lang.String subString, int from, QTextDocument.FindFlag... options)` Finds the next occurrence of the string, `subString`, in the document.
`QTextCursor` | `find(java.lang.String subString, int from, QTextDocument.FindFlags options)` Finds the next occurrence of the string, `subString`, in the document.
`QTextCursor` | `find(java.lang.String subString, QTextCursor from)` Equivalent to find(`subString`, `from`, 0).
`QTextCursor` | `find(java.lang.String subString, QTextCursor from, QTextDocument.FindFlag... options)` Finds the next occurrence of the string, `subString`, in the document.
`QTextCursor` | `find(java.lang.String subString, QTextCursor from, QTextDocument.FindFlags options)` Finds the next occurrence of the string, `subString`, in the document.
`QTextBlock` | `findBlock(int pos)` Returns the text block that contains the `pos`-th character.
`QTextFrame` | `frameAt(int pos)`
`static QTextDocument` | `fromNativePointer(QNativePointer nativePointer)` This function returns the QTextDocument instance pointed to by nativePointer
`double` | `idealWidth()` Returns the ideal width of the text document.
`boolean` | `isEmpty()` Returns true if the document is empty; otherwise returns false.
`boolean` | `isModified()` Returns whether the document has been modified by the user.
`boolean` | `isRedoAvailable()` Returns true if redo is available; otherwise returns false.
`boolean` | `isUndoAvailable()` Returns true if undo is available; otherwise returns false.
`boolean` | `isUndoRedoEnabled()` Returns whether undo/redo are enabled for this document.
`protected java.lang.Object` | `loadResource(int type, QUrl name)` Loads data of the specified `type` from the resource with the given `name`.
`void` | `markContentsDirty(int from, int length)` Marks the contents specified by the given `from` and `length` as "dirty", informing the document that it needs to be laid out again.
`int` | `maximumBlockCount()` Returns Specifies the limit for blocks in the document..
`java.lang.String` | `metaInformation(QTextDocument.MetaInformation info)` Returns meta information about the document of the type specified by `info`.
`QTextObject` | `object(int objectIndex)` Returns the text object associated with the given `objectIndex`.
`QTextObject` | `objectForFormat(QTextFormat arg__1)` Returns the text object associated with the format `arg__1`.
`int` | `pageCount()` returns the number of pages in this document.
`QSizeF` | `pageSize()` Returns the page size that should be used for laying out the document.
`void` | `print(QPrinter printer)` Prints the document to the given `printer`.
`void` | `redo()` Redoes the last editing operation on the document if redo is available.
`void` | `redo(QTextCursor cursor)` Redoes the last editing operation on the document if QTextDocument.isRedoAvailable() redo is available.
`java.lang.Object` | `resource(int type, QUrl name)` Returns data of the specified `type` from the resource with the given `name`.
`QTextFrame` | `rootFrame()` Returns the document's root frame.
`void` | `setDefaultFont(QFont font)` Sets the default font used to display the document's text to `font`.
`void` | `setDefaultStyleSheet(java.lang.String sheet)` The default style sheet is applied to all newly HTML formatted text that is inserted into the document, for example using `setHtml` or QTextCursor::insertHtml().
`void` | `setDefaultTextOption(QTextOption option)` Sets the default text option will be set on all `QTextLayout`s in the document.
`void` | `setDocumentLayout(QAbstractTextDocumentLayout layout)` Sets the document to use the given `layout`.
`void` | `setHtml(java.lang.String html)` Replaces the entire contents of the document with the given HTML-formatted text in the `html` string.
`void` | `setMaximumBlockCount(int maximum)` Sets Specifies the limit for blocks in the document.
`void` | `setMetaInformation(QTextDocument.MetaInformation info, java.lang.String arg__2)` Sets the document's meta information of the type specified by `info` to the given `arg__2`.
`void` | `setModified()` Equivalent to `setModified`(true).
`void` | `setModified(boolean m)` Sets whether the document has been modified by the user to `m`.
`void` | `setPageSize(QSizeF size)` Sets the page size that should be used for laying out the document to `size`.
`void` | `setPlainText(java.lang.String text)` Replaces the entire contents of the document with the given plain `text`.
`void` | `setTextWidth(double width)` The text width specifies the preferred width for text in the document.
`void` | `setUndoRedoEnabled(boolean enable)` Sets whether undo/redo are enabled for this document to `enable`.
`void` | `setUseDesignMetrics(boolean b)` If `b` is true then the layout will use design metrics; otherwise it will use the metrics of the paint device (which is the default behavior).
`QSizeF` | `size()` Returns the actual size of the document.
`double` | `textWidth()` The text width specifies the preferred width for text in the document.
`java.lang.String` | `toHtml()` Equivalent to `toHtml`(QByteArray()).
`java.lang.String` | `toHtml(QByteArray encoding)` Returns a string containing an HTML representation of the document.
`java.lang.String` | `toPlainText()` Returns the plain text contained in the document.
`void` | `undo()` This is an overloaded member function, provided for convenience.
`void` | `undo(QTextCursor cursor)` Undoes the last editing operation on the document if undo is available.
`boolean` | `useDesignMetrics()` Returns true if this QTextDocument uses design metrics.

Methods inherited from class com.trolltech.qt.core.QObject
`blockSignals, childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, event, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, property, removeEventFilter, setObjectName, setParent, setProperty, signalsBlocked, startTimer, thread, timerEvent`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`disconnect, disconnect, signalSender`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Field Detail

### blockCountChanged

    public final QSignalEmitter.Signal1<java.lang.Integer> blockCountChanged

  This signal is emitted when the total number of text blocks in the document changes. The value passed in `newBlockCount` is the new total.

  Compatible Slot Signatures:
    `void mySlot(int newBlockCount)`
    `void mySlot()`

### contentsChange

    public final QSignalEmitter.Signal3<java.lang.Integer,java.lang.Integer,java.lang.Integer> contentsChange

  This signal is emitted whenever the document's content changes; for example, when text is inserted or deleted, or when formatting is applied.

  Information is provided about the `from` of the character in the document where the change occurred, the number of characters removed (`charsRemoves`), and the number of characters added (`charsAdded`).

  The signal is emitted before the document's layout manager is notified about the change. This hook allows you to implement syntax highlighting for the document.

  Compatible Slot Signatures:
    `void mySlot(int from, int charsRemoves, int charsAdded)`
    `void mySlot(int from, int charsRemoves)`
    `void mySlot(int from)`
    `void mySlot()`
  See Also:
    `QAbstractTextDocumentLayout::documentChanged`, `contentsChanged`

### contentsChanged

    public final QSignalEmitter.Signal0 contentsChanged

  This signal is emitted whenever the document's content changes; for example, when text is inserted or deleted, or when formatting is applied.

  Compatible Slot Signature:
    `void mySlot()`
  See Also:
    `contentsChange`

### cursorPositionChanged

    public final QSignalEmitter.Signal1<QTextCursor> cursorPositionChanged

  This signal is emitted whenever the position of a cursor changed due to an editing operation. The cursor that changed is passed in `cursor`. If you need a signal when the cursor is moved with the arrow keys you can use the cursorPositionChanged() signal in `QTextEdit`.

  Compatible Slot Signatures:
    `void mySlot(com.trolltech.qt.gui.QTextCursor cursor)`
    `void mySlot()`

### modificationChanged

    public final QSignalEmitter.Signal1<java.lang.Boolean> modificationChanged

  This signal is emitted whenever the content of the document changes in a way that affects the modification state. If `m` is true, the document has been modified; otherwise it is false.

  For example, calling `setModified`(false) on a document and then inserting text causes the signal to get emitted. If you undo that operation, causing the document to return to its original unmodified state, the signal will get emitted again.

  Compatible Slot Signatures:
    `void mySlot(boolean m)`
    `void mySlot()`

### redoAvailable

    public final QSignalEmitter.Signal1<java.lang.Boolean> redoAvailable

  This signal is emitted whenever redo operations become available (`arg__1` is true) or unavailable (`arg__1` is false).

  Compatible Slot Signatures:
    `void mySlot(boolean arg__1)`
    `void mySlot()`

### undoAvailable

    public final QSignalEmitter.Signal1<java.lang.Boolean> undoAvailable

  This signal is emitted whenever undo operations become available (`arg__1` is true) or unavailable (`arg__1` is false).

  See the Qt Undo Framework documentation for details.

  Compatible Slot Signatures:
    `void mySlot(boolean arg__1)`
    `void mySlot()`
  See Also:
    `undo`, `isUndoRedoEnabled`

Constructor Detail

### QTextDocument

    public QTextDocument()

  Equivalent to `QTextDocument`(0).

### QTextDocument

    public QTextDocument(QObject parent)

  Constructs an empty `QTextDocument` with the given `parent`.

### QTextDocument

    public QTextDocument(java.lang.String text)

  Equivalent to `QTextDocument`(`text`, 0).

### QTextDocument

    public QTextDocument(java.lang.String text,
                         QObject parent)

  Constructs a `QTextDocument` containing the plain (unformatted) `text` specified, and with the given `parent`.

Method Detail

### addResource

    public final void addResource(int type,
                                  QUrl name,
                                  java.lang.Object resource)

  Adds the resource `resource` to the resource cache, using `type` and `name` as identifiers. `type` should be a value from QTextDocument::ResourceType.

### adjustSize

    public final void adjustSize()

  Adjusts the document to a reasonable size.

  See Also:
    `idealWidth`, `textWidth`, size

### allFormats

    public final java.util.List<QTextFormat> allFormats()

  Returns a vector of text formats for all the formats used in the document.

### begin

    public final QTextBlock begin()

  Returns the document's first text block.

### blockCount

    public final int blockCount()

  Returns the number of text blocks in the document.

  The value of this property is undefined in documents with tables or frames.

### clone

    public final QTextDocument clone()

  Equivalent to clone(0).

  Overrides:
    `clone` in class `java.lang.Object`

### clone

    public final QTextDocument clone(QObject parent)

  Creates a new `QTextDocument` that is a copy of this text document. `parent` is the parent of the returned text document.

### defaultFont

    public final QFont defaultFont()

  Returns the default font used to display the document's text.

  See Also:
    `setDefaultFont`

### defaultStyleSheet

    public final java.lang.String defaultStyleSheet()

  The default style sheet is applied to all newly HTML formatted text that is inserted into the document, for example using `setHtml` or QTextCursor::insertHtml().

  The style sheet needs to be compliant to CSS 2.1 syntax.

  Note: Changing the default style sheet does not have any effect to the existing content of the document.

  See Also:
    `setDefaultStyleSheet`, Supported HTML Subset

### defaultTextOption

    public final QTextOption defaultTextOption()

  Returns the default text option will be set on all `QTextLayout`s in the document..

  When `QTextBlock`s are created, the `defaultTextOption` is set on their `QTextLayout`. This allows setting global properties for the document such as the default word wrap mode.

  See Also:
    `setDefaultTextOption`

### documentLayout

    public final QAbstractTextDocumentLayout documentLayout()

  Returns the document layout for this document.

  See Also:
    `setDocumentLayout`

### drawContents

    public final void drawContents(QPainter painter)

  Equivalent to `drawContents`(`painter`, QRectF()).

### drawContents

    public final void drawContents(QPainter painter,
                                   QRectF rect)

  Draws the content of the document with painter `painter`, clipped to `rect`. If `rect` is a null rectangle (default) then the document is painted unclipped.

### end

    public final QTextBlock end()

  This function returns a block to test for the end of the document while iterating over it.

              for (QTextBlock it = doc->begin(); it != doc->end(); it = it.next())
                  cout << it.text().toStdString() << endl;

  The block returned is invalid and represents the block after the last block in the document.

### find

    public final QTextCursor find(java.lang.String subString,
                                  QTextCursor from,
                                  QTextDocument.FindFlag... options)

  Finds the next occurrence of the string, `subString`, in the document. The search starts at the position of the given `from`, and proceeds forwards through the document unless specified otherwise in the search options. The `options` control the type of search performed.

  Returns a cursor with the match selected if `subString` was found; otherwise returns a null cursor.

  If the given `from` has a selection, the search begins after the selection; otherwise it begins at the cursor's position.

  By default the search is case-sensitive, and can match text anywhere in the document.

### find

    public final QTextCursor find(java.lang.String subString,
                                  QTextCursor from)

  Equivalent to find(`subString`, `from`, 0).

### find

    public final QTextCursor find(java.lang.String subString,
                                  QTextCursor from,
                                  QTextDocument.FindFlags options)

  Finds the next occurrence of the string, `subString`, in the document. The search starts at the position of the given `from`, and proceeds forwards through the document unless specified otherwise in the search options. The `options` control the type of search performed.

  Returns a cursor with the match selected if `subString` was found; otherwise returns a null cursor.

  If the given `from` has a selection, the search begins after the selection; otherwise it begins at the cursor's position.

  By default the search is case-sensitive, and can match text anywhere in the document.

### find

    public final QTextCursor find(QRegExp expr,
                                  QTextCursor from,
                                  QTextDocument.FindFlag... options)

  Finds the next occurrence, matching the regular expression, `expr`, in the document. The search starts at the position of the given `from`, and proceeds forwards through the document unless specified otherwise in the search options. The `options` control the type of search performed. The `FindCaseSensitively` option is ignored for this overload, use QRegExp::caseSensitivity instead.

  Returns a cursor with the match selected if a match was found; otherwise returns a null cursor.

  If the given `from` has a selection, the search begins after the selection; otherwise it begins at the cursor's position.

  By default the search is case-sensitive, and can match text anywhere in the document.

### find

    public final QTextCursor find(QRegExp expr,
                                  QTextCursor from)

  Equivalent to find(`expr`, `from`, 0).

### find

    public final QTextCursor find(QRegExp expr,
                                  QTextCursor from,
                                  QTextDocument.FindFlags options)

  Finds the next occurrence, matching the regular expression, `expr`, in the document. The search starts at the position of the given `from`, and proceeds forwards through the document unless specified otherwise in the search options. The `options` control the type of search performed. The `FindCaseSensitively` option is ignored for this overload, use QRegExp::caseSensitivity instead.

  Returns a cursor with the match selected if a match was found; otherwise returns a null cursor.

  If the given `from` has a selection, the search begins after the selection; otherwise it begins at the cursor's position.

  By default the search is case-sensitive, and can match text anywhere in the document.

### find

    public final QTextCursor find(java.lang.String subString,
                                  int from,
                                  QTextDocument.FindFlag... options)

  Finds the next occurrence of the string, `subString`, in the document. The search starts at the given `from`, and proceeds forwards through the document unless specified otherwise in the search options. The `options` control the type of search performed.

  Returns a cursor with the match selected if `subString` was found; otherwise returns a null cursor.

  If the `from` is 0 (the default) the search begins from the beginning of the document; otherwise it begins at the specified position.

### find

    public final QTextCursor find(java.lang.String subString,
                                  int from)

  Equivalent to find(`subString`, `from`, 0).

### find

    public final QTextCursor find(java.lang.String subString)

  Equivalent to find(`subString`, 0, 0).

### find

    public final QTextCursor find(java.lang.String subString,
                                  int from,
                                  QTextDocument.FindFlags options)

  Finds the next occurrence of the string, `subString`, in the document. The search starts at the given `from`, and proceeds forwards through the document unless specified otherwise in the search options. The `options` control the type of search performed.

  Returns a cursor with the match selected if `subString` was found; otherwise returns a null cursor.

  If the `from` is 0 (the default) the search begins from the beginning of the document; otherwise it begins at the specified position.

### find

    public final QTextCursor find(QRegExp expr,
                                  int from,
                                  QTextDocument.FindFlag... options)

  Finds the next occurrence, matching the regular expression, `expr`, in the document. The search starts at the given `from`, and proceeds forwards through the document unless specified otherwise in the search options. The `options` control the type of search performed. The `FindCaseSensitively` option is ignored for this overload, use QRegExp::caseSensitivity instead.

  Returns a cursor with the match selected if a match was found; otherwise returns a null cursor.

  If the `from` is 0 (the default) the search begins from the beginning of the document; otherwise it begins at the specified position.

### find

    public final QTextCursor find(QRegExp expr,
                                  int from)

  Equivalent to find(`expr`, `from`, 0).

### find

    public final QTextCursor find(QRegExp expr)

  Equivalent to find(`expr`, 0, 0).

### find

    public final QTextCursor find(QRegExp expr,
                                  int from,
                                  QTextDocument.FindFlags options)

  Finds the next occurrence, matching the regular expression, `expr`, in the document. The search starts at the given `from`, and proceeds forwards through the document unless specified otherwise in the search options. The `options` control the type of search performed. The `FindCaseSensitively` option is ignored for this overload, use QRegExp::caseSensitivity instead.

  Returns a cursor with the match selected if a match was found; otherwise returns a null cursor.

  If the `from` is 0 (the default) the search begins from the beginning of the document; otherwise it begins at the specified position.

### findBlock

    public final QTextBlock findBlock(int pos)

  Returns the text block that contains the `pos`-th character.

### frameAt

    public final QTextFrame frameAt(int pos)

### idealWidth

    public final double idealWidth()

  Returns the ideal width of the text document. The ideal width is the actually used width of the document without optional alignments taken into account. It is always <= `size`.width().

  See Also:
    `adjustSize`, `textWidth`

### isEmpty

    public final boolean isEmpty()

  Returns true if the document is empty; otherwise returns false.

### isModified

    public final boolean isModified()

  Returns whether the document has been modified by the user.

  See Also:
    `modificationChanged`

### isRedoAvailable

    public final boolean isRedoAvailable()

  Returns true if redo is available; otherwise returns false.

### isUndoAvailable

    public final boolean isUndoAvailable()

  Returns true if undo is available; otherwise returns false.

### isUndoRedoEnabled

    public final boolean isUndoRedoEnabled()

  Returns whether undo/redo are enabled for this document.

  This defaults to true. If disabled, the undo stack is cleared and no items will be added to it.

### markContentsDirty

    public final void markContentsDirty(int from,
                                        int length)

  Marks the contents specified by the given `from` and `length` as "dirty", informing the document that it needs to be laid out again.

### maximumBlockCount

    public final int maximumBlockCount()

  Returns Specifies the limit for blocks in the document..

  Specifies the maximum number of blocks the document may have. If there are more blocks in the document that specified with this property blocks are removed from the beginning of the document.

  A negative or zero value specifies that the document may contain an unlimited amount of blocks.

  The default value is 0.

  Note that setting this property will apply the limit immediately to the document contents.

  Setting this property also disables the undo redo history.

  This property is undefined in documents with tables or frames.

  See Also:
    `setMaximumBlockCount`

### metaInformation

    public final java.lang.String metaInformation(QTextDocument.MetaInformation info)

  Returns meta information about the document of the type specified by `info`.

  See Also:
    `setMetaInformation`

### object

    public final QTextObject object(int objectIndex)

  Returns the text object associated with the given `objectIndex`.

### objectForFormat

    public final QTextObject objectForFormat(QTextFormat arg__1)

  Returns the text object associated with the format `arg__1`.

### pageCount

    public final int pageCount()

  returns the number of pages in this document.

### pageSize

    public final QSizeF pageSize()

  Returns the page size that should be used for laying out the document.

  See Also:
    `setPageSize`, `modificationChanged`

### print

    public final void print(QPrinter printer)

  Prints the document to the given `printer`. The `QPrinter` must be set up before being used with this function.

  This is only a convenience method to print the whole document to the printer.

  If the document is already paginated through a specified height in the `pageSize` property it is printed as-is.

  If the document is not paginated, like for example a document used in a `QTextEdit`, then a temporary copy of the document is created and the copy is broken into multiple pages according to the size of the `QPrinter`'s paperRect(). By default a 2 cm margin is set around the document contents. In addition the current page number is printed at the bottom of each page.

  Note that QPrinter::Selection is not supported as print range with this function since the selection is a property of `QTextCursor`. If you have a `QTextEdit` associated with your `QTextDocument` then you can use `QTextEdit`'s `print` function because `QTextEdit` has access to the user's selection.

  See Also:
    `QTextEdit::print`

### redo

    public final void redo()

  Redoes the last editing operation on the document if redo is available.

### resource

    public final java.lang.Object resource(int type,
                                           QUrl name)

  Returns data of the specified `type` from the resource with the given `name`.

  This function is called by the rich text engine to request data that isn't directly stored by `QTextDocument`, but still associated with it. For example, images are referenced indirectly by the name attribute of a `QTextImageFormat` object.

  Resources are cached internally in the document. If a resource can not be found in the cache, `loadResource` is called to try to load the resource. `loadResource` should then use `addResource` to add the resource to the cache.

### rootFrame

    public final QTextFrame rootFrame()

  Returns the document's root frame.

### setDefaultFont

    public final void setDefaultFont(QFont font)

  Sets the default font used to display the document's text to `font`.

  See Also:
    `defaultFont`

### setDefaultStyleSheet

    public final void setDefaultStyleSheet(java.lang.String sheet)

  The default style sheet is applied to all newly HTML formatted text that is inserted into the document, for example using `setHtml` or QTextCursor::insertHtml().

  The style sheet needs to be compliant to CSS 2.1 syntax.

  Note: Changing the default style sheet does not have any effect to the existing content of the document.

  See Also:
    `defaultStyleSheet`, Supported HTML Subset

### setDefaultTextOption

    public final void setDefaultTextOption(QTextOption option)

  Sets the default text option will be set on all `QTextLayout`s in the document. to `option`.

  When `QTextBlock`s are created, the `defaultTextOption` is set on their `QTextLayout`. This allows setting global properties for the document such as the default word wrap mode.

  See Also:
    `defaultTextOption`

### setDocumentLayout

    public final void setDocumentLayout(QAbstractTextDocumentLayout layout)

  Sets the document to use the given `layout`. The previous layout is deleted.

  Note that when setting a new layout for a `QTextEdit` you have to create a new `QTextDocument` first, set the new layout on it and then set the new document on `QTextEdit`.

  See Also:
    `documentLayout`

### setHtml

    public final void setHtml(java.lang.String html)

  Replaces the entire contents of the document with the given HTML-formatted text in the `html` string.

  The HTML formatting is respected as much as possible; for example, "<b>bold</b> text" will produce text where the first word has a font weight that gives it a bold appearance: "bold text".

  Note: It is the responsibility of the caller to make sure that the text is correctly decoded when a `QString` containing HTML is created and passed to `setHtml`.

  See Also:
    `setPlainText`, Supported HTML Subset

### setMaximumBlockCount

    public final void setMaximumBlockCount(int maximum)

  Sets Specifies the limit for blocks in the document. to `maximum`.

  Specifies the maximum number of blocks the document may have. If there are more blocks in the document that specified with this property blocks are removed from the beginning of the document.

  A negative or zero value specifies that the document may contain an unlimited amount of blocks.

  The default value is 0.

  Note that setting this property will apply the limit immediately to the document contents.

  Setting this property also disables the undo redo history.

  This property is undefined in documents with tables or frames.

  See Also:
    `maximumBlockCount`

### setMetaInformation

    public final void setMetaInformation(QTextDocument.MetaInformation info,
                                         java.lang.String arg__2)

  Sets the document's meta information of the type specified by `info` to the given `arg__2`.

  See Also:
    `metaInformation`

### setModified

    public final void setModified()

  Equivalent to `setModified`(true).

### setModified

    public final void setModified(boolean m)

  Sets whether the document has been modified by the user to `m`.

  See Also:
    `isModified`, `modificationChanged`

### setPageSize

    public final void setPageSize(QSizeF size)

  Sets the page size that should be used for laying out the document to `size`.

  See Also:
    `pageSize`, `modificationChanged`

### setPlainText

    public final void setPlainText(java.lang.String text)

  Replaces the entire contents of the document with the given plain `text`.

  See Also:
    `setHtml`

### setTextWidth

    public final void setTextWidth(double width)

  The text width specifies the preferred width for text in the document. If the text (or content in general) is wider than the specified with it is broken into multiple lines and grows vertically. If the text cannot be broken into multiple lines to fit into the specified text width it will be larger and the `size` and the `idealWidth` property will reflect that.

  If the text width is set to -1 then the text will not be broken into multiple lines unless it is enforced through an explicit line break or a new paragraph.

  The default value is -1.

  Setting the text width will also set the page height to -1, causing the document to grow or shrink vertically in a continuous way. If you want the document layout to break the text into multiple pages then you have to set the `pageSize` property instead.

  See Also:
    `textWidth`, `size`, `idealWidth`, `pageSize`

### setUndoRedoEnabled

    public final void setUndoRedoEnabled(boolean enable)

  Sets whether undo/redo are enabled for this document to `enable`.

  This defaults to true. If disabled, the undo stack is cleared and no items will be added to it.

  See Also:
    `isUndoRedoEnabled`

### setUseDesignMetrics

    public final void setUseDesignMetrics(boolean b)

  If `b` is true then the layout will use design metrics; otherwise it will use the metrics of the paint device (which is the default behavior).

### size

    public final QSizeF size()

  Returns the actual size of the document. This is equivalent to `documentLayout`->documentSize();

  The size of the document can be changed either by setting a text width or setting an entire page size.

  Note that the width is always >= `pageSize`.width().

  See Also:
    `setTextWidth`, `setPageSize`, `idealWidth`

### textWidth

    public final double textWidth()

  The text width specifies the preferred width for text in the document. If the text (or content in general) is wider than the specified with it is broken into multiple lines and grows vertically. If the text cannot be broken into multiple lines to fit into the specified text width it will be larger and the `size` and the `idealWidth` property will reflect that.

  If the text width is set to -1 then the text will not be broken into multiple lines unless it is enforced through an explicit line break or a new paragraph.

  The default value is -1.

  Setting the text width will also set the page height to -1, causing the document to grow or shrink vertically in a continuous way. If you want the document layout to break the text into multiple pages then you have to set the `pageSize` property instead.

  See Also:
    `setTextWidth`, `size`, `idealWidth`, `pageSize`

### toHtml

    public final java.lang.String toHtml()

  Equivalent to `toHtml`(QByteArray()).

### toHtml

    public final java.lang.String toHtml(QByteArray encoding)

  Returns a string containing an HTML representation of the document.

  The `encoding` parameter specifies the value for the charset attribute in the html header. For example if 'utf-8' is specified then the beginning of the generated html will look like this:

          <html><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8"></head><body>...

  If no encoding is specified then no such meta information is generated.

  If you later on convert the returned html string into a byte array for transmission over a network or when saving to disk you should specify the encoding you're going to use for the conversion to a byte array here.

  See Also:
    Supported HTML Subset

### toPlainText

    public final java.lang.String toPlainText()

  Returns the plain text contained in the document. If you want formatting information use a `QTextCursor` instead.

  See Also:
    `toHtml`

### undo

    public final void undo()

  This is an overloaded member function, provided for convenience.

### useDesignMetrics

    public final boolean useDesignMetrics()

  Returns true if this QTextDocument uses design metrics.

### clear

    public void clear()

  Clears the document.

### createObject

    protected QTextObject createObject(QTextFormat f)

  Creates and returns a new document object (a `QTextObject`), based on the given `f`.

  QTextObjects will always get created through this method, so you must reimplement it if you use custom text objects inside your document.

### loadResource

    protected java.lang.Object loadResource(int type,
                                            QUrl name)

  Loads data of the specified `type` from the resource with the given `name`.

  This function is called by the rich text engine to request data that isn't directly stored by `QTextDocument`, but still associated with it. For example, images are referenced indirectly by the name attribute of a `QTextImageFormat` object.

  When called by Qt, `type` is one of the values of QTextDocument::ResourceType.

  If the `QTextDocument` is a child object of a `QTextEdit`, `QTextBrowser`, or a `QTextDocument` itself then the default implementation tries to retrieve the data from the parent.

### fromNativePointer

    public static QTextDocument fromNativePointer(QNativePointer nativePointer)

  This function returns the QTextDocument instance pointed to by nativePointer

  Parameters:
    `nativePointer` - the QNativePointer of which object should be returned.

### redo

    public final void redo(QTextCursor cursor)

  Redoes the last editing operation on the document if QTextDocument.isRedoAvailable() redo is available.

  The provided `cursor` is positioned at the end of the location where the edition operation was redone.

### undo

    public final void undo(QTextCursor cursor)

  Undoes the last editing operation on the document if undo is available. The provided `cursor` is positioned at the end of the location where the edition operation was undone.

  See the \l {Overview of Qt's Undo Framework}{Qt Undo Framework} documentation for details.

Overview | Package | Class | Tree | Deprecated | Index | Help
Qt Jambi Home |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD